package com.inca.npbusi.sales.bms_sa_con;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ParamCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.DefaultNPParam;
import com.inca.np.util.SendHelper;
import com.inca.npx.ste.Apinfo;
import com.inca.npx.ste.CSteModelAp;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import java.math.BigDecimal;
import java.util.Vector;
import javax.swing.JOptionPane;
import org.apache.log4j.Category;

public class Sa_con_doc_ste extends CSteModelAp {
   private Category a = Category.getInstance(Sa_con_doc_ste.class);
   private String b = "";
   private String c = "";
   protected String saconmultiexec = "";

   public String getEntryid() {
      return this.b;
   }

   public void setEntryid(String var1) {
      this.b = var1;
   }

   public String getEntryname() {
      return this.c;
   }

   public void setEntryname(String var1) {
      this.c = var1;
   }

   public Sa_con_doc_ste() {
   }

   public Sa_con_doc_ste(CFrame var1) {
      super(var1, "销售订单总单");
      if (!DefaultNPParam.runonserver) {
         this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
         this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
         this.saconmultiexec = NpbusiDBHelper.getSysParaConfig(this.b, "saconmultiexec");
      }

   }

   public String getTablename() {
      return "bms_sa_con_doc_v";
   }

   public String getSaveCommandString() {
      return "com.inca.npbusi.sales.Sa_con_doc_ste.保存订单总单";
   }

   protected String getOtherWheres() {
      String var1 = super.getOtherWheres();
      String var2;
      if ((var2 = this.getEntryid()) != null && !var2.equals("")) {
         return "(approveflag =1 or approveflag =3) and usestatus = 2 and (comefrom = 1 or(comefrom=2 and contype=3 and storageid is not null)) and entryid = " + var2 + var1;
      } else {
         this.warnMessage("提示", "当前登录的角色没有指定独立单元，不能操作！");
         return null;
      }
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("发货保管账集合", ""));
      var1.add(new Apinfo("准许出库配货", ""));
      var1.add(new Apinfo("自动出库配货", ""));
      var1.add(new Apinfo("自动出库记保管账", ""));
      var1.add(new Apinfo("自提允许配货", ""));
      var1.add(new Apinfo("库存选择到货品状态", ""));
      var1.add(new Apinfo("库存自动缺货登记", ""));
      var1.add(new Apinfo("证照控制", ""));
      var1.add(new Apinfo("提示天数", ""));
      var1.add(new Apinfo("是否在生成发货单时取消按批号批次货位分组", ""));
      var1.add(new Apinfo("非严格控制批次限销", ""));
      return var1;
   }

   protected int on_actionPerformed(String var1) {
      if (!var1.equals("销售分配")) {
         if (var1.equals("切换独立单元")) {
            if (this.getModifiedDbmodel().getRowCount() > 0) {
               this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
               return -1;
            } else if (((Bms_sa_con_frame)this.getParentFrame()).getGoodsdtlModelSte().getModifiedDbmodel().getRowCount() > 0) {
               this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
               return -1;
            } else {
               if (Entrychose.setUserEntryInfo(this.frame)) {
                  this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                  this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                  ((Sa_con_dtl_mde)((Bms_sa_con_frame)this.getParentFrame()).getMdemodel()).setEntryid(ClientUserManager.getCurrentUser().getEntryid());
                  ((Sa_con_dtl_mde)((Bms_sa_con_frame)this.getParentFrame()).getMdemodel()).setEntryname(ClientUserManager.getCurrentUser().getEntryname());
                  this.doRetrieve("1=2");
                  this.saconmultiexec = NpbusiDBHelper.getSysParaConfig(this.b, "saconmultiexec");
               }

               return 0;
            }
         } else if (var1.equals("订单执行")) {
            this.b();
            return 0;
         } else if (var1.equals("订单完成")) {
            this.a();
            return 0;
         } else {
            return super.on_actionPerformed(var1);
         }
      } else {
         Sa_con_doc_ste var18 = this;
         DBTableModel var2 = ((Bms_sa_con_frame)this.getParentFrame()).getCondtlModel();
         int[] var3 = ((Bms_sa_con_frame)this.getParentFrame()).getModelCondtl().getTable().getSelectedRows();
         String var4 = null;
         String var5 = null;
         String var6 = null;
         var4 = null;
         if (this.dbmodel.getRowCount() <= 0) {
            this.warnMessage("警告", "请查询后，选择单据进行销售分配!");
         } else if (this.getTable().getSelectedRowCount() <= 0) {
            this.warnMessage("警告", "请选择单据进行销售分配!");
         } else if (this.getTable().getRow() == this.dbmodel.getRowCount()) {
            this.warnMessage("警告", "请正确选择单据!");
         } else {
            for(int var22 = 0; var22 < var18.getTable().getRowCount(); ++var22) {
               if (var18.getModifiedDbmodel().getRowCount() > 0) {
                  var18.warnMessage("警告", "没有保存不能销售分配,请先保存!");
                  return 0;
               }
            }

            var4 = var18.saconmultiexec;
            int var7 = var18.getRow();
            int var8;
            String var9;
            String var10;
            String var11;
            boolean var23;
            int var25;
            if ("1".equals(var4)) {
               for(var8 = 0; var8 < var2.getRowCount(); ++var8) {
                  var23 = false;

                  for(var25 = 0; var25 < var3.length; ++var25) {
                     if (var8 == var3[var25]) {
                        var23 = true;
                     }
                  }

                  if (var23) {
                     var5 = var2.getItemValue(var8, "goodsqty");
                     var4 = var2.getItemValue(var8, "saplaceqty");
                     var6 = var2.getItemValue(var8, "usestatus");
                     if ("1".equals(var6)) {
                        var18.warnMessage("警告", "订单细单第" + (var8 + 1) + "行已完成，不允许再次分配!");
                        return 0;
                     }

                     var9 = var2.getItemValue(var8, "goodsid");
                     var10 = var2.getItemValue(var8, "goodsname");
                     var11 = var18.getItemValue(var7, "customid");
                     DBTableModel var12;
                     String var13 = (var12 = var18.a(var9, var11)).getItemValue(0, "limitedsaleflag");
                     var9 = var12.getItemValue(0, "allotqty");
                     if (var4 == null || var4.length() == 0) {
                        var4 = "0";
                     }

                     var6 = var2.getItemValue(var8, "plansaplaceqty");
                     var4 = DecimalHelper.sub(var5, var4, 6);
                     if (DecimalHelper.toDec(var6).compareTo(DecimalHelper.toDec(var4)) > 0) {
                        var18.warnMessage("警告", "订单细单第" + (var8 + 1) + "行的预分配数量过大，请检查!");
                        return 0;
                     }

                     if ("1".equals(var13)) {
                        if (DecimalHelper.toDec(var9).compareTo(DecimalHelper.toDec(var6)) < 0) {
                           var18.infoMessage("提示", "货品:" + var10 + "为配额销售货品，当前可用配额为" + var9 + "，\n预分配数量不得大于可用配额，请检查!");
                           return 0;
                        }

                        var18.a.error("配额销售，预分配数量正常，为" + var6);
                     } else {
                        var18.a.error("非配额销售，预分配数量正常，为" + var6);
                     }
                  }
               }
            } else {
               for(var8 = 0; var8 < var2.getRowCount(); ++var8) {
                  var23 = false;

                  for(var25 = 0; var25 < var3.length; ++var25) {
                     if (var8 == var3[var25]) {
                        var23 = true;
                     }
                  }

                  if (var23) {
                     var4 = var2.getItemValue(var8, "saplaceqty");
                     var6 = var2.getItemValue(var8, "plansaplaceqty");
                     var6 = DecimalHelper.sub(var5 = var2.getItemValue(var8, "goodsqty"), var6, 6);
                     var9 = var2.getItemValue(var8, "usestatus");
                     if ("1".equals(var9)) {
                        var18.warnMessage("警告", "订单细单第" + (var8 + 1) + "行已完成，不允许再次分配!");
                        return 0;
                     }

                     if (var5.compareTo(var4) == 0) {
                        var18.warnMessage("警告", "订单细单第" + (var8 + 1) + "行已销售分配，不允许再次分配，不允许再次分配!");
                        return 0;
                     }

                     if (var4 == null || var4.length() == 0) {
                        var4 = "0";
                     }

                     if (DecimalHelper.toDec(var4).compareTo(DecimalHelper.toDec("0")) > 0) {
                        var18.warnMessage("警告", "目前不允许订单多次执行,订单细单第" + (var8 + 1) + "行已经做过分配，请检查!");
                        return 0;
                     }

                     if (DecimalHelper.toDec(var6).compareTo(new BigDecimal("0")) != 0) {
                        var18.warnMessage("提示", "目前不允许订单多次执行，订单细单第" + (var8 + 1) + "行的预分配数量需要等于订单数量;");
                        return 0;
                     }
                  }
               }
            }

            int[] var27 = var18.getTable().getSelectedRows();
            var18.getRowCount();
            Vector var28 = new Vector();
            DBColumnDisplayInfo var24 = new DBColumnDisplayInfo("conid", "number");
            var28.add(var24);
            var24 = new DBColumnDisplayInfo("message", "varchar");
            var28.add(var24);
            var24 = new DBColumnDisplayInfo("sabmsstset", "varchar");
            var28.add(var24);
            var24 = new DBColumnDisplayInfo("bmsgmoosrecflag", "number");
            var28.add(var24);
            DBTableModel var26 = new DBTableModel(var28);
            var9 = var18.getApvalue("库存自动缺货登记");
            int var29 = 0;

            while(true) {
               if (var29 >= var27.length) {
                  var10 = "";
                  if (var3.length > 0) {
                     var10 = var2.getItemValue(var3[0], "condtlid");
                  }

                  ClientRequest var31 = new ClientRequest();
                  StringCommand var33 = new StringCommand("Bms_sa_con_mde.销售订单发货销售分配");
                  DataCommand var35 = new DataCommand();
                  DataCommand var30 = new DataCommand();
                  ParamCommand var20 = new ParamCommand();
                  var35.setDbmodel(var26);
                  var30.setDbmodel(var2);
                  var20.addParam("paramcondtlid", var10);
                  var31.addCommand(var33);
                  var31.addCommand(var35);
                  var31.addCommand(var30);
                  var31.addCommand(var20);
                  var31.addCommand(new StringCommand(var18.getEntryid()));
                  var31.addCommand(new StringCommand(var18.saconmultiexec));
                  var18.setWaitCursor();

                  try {
                     try {
                        StringCommand var19;
                        if ((var19 = (StringCommand)SendHelper.sendRequest(var31).commandAt(0)).getString().startsWith("+OK")) {
                           var18.infoMessage("提示", "销售分配成功！");
                           ((Bms_sa_con_frame)var18.getParentFrame()).getModelCondtl().doRequery();
                        } else if (var19.getString().startsWith("-ERROR")) {
                           int var21 = var19.getString().indexOf(58);
                           var18.warnMessage("提示", "销售分配失败：" + var19.getString().substring(var21 + 1));
                        }
                     } catch (Exception var16) {
                        var18.errorMessage("错误", var16.getMessage());
                     }
                     break;
                  } finally {
                     var18.setDefaultCursor();
                  }
               }

               var11 = var18.getItemValue(var27[var29], "conid");
               String var32;
               if ((var32 = var18.getItemValue(var27[var29], "storageid")) == null || var32.trim().length() <= 0) {
                  var18.infoMessage("提示", "没有指定保管帐不能配出货品");
                  break;
               }

               int var34 = var26.getRowCount();
               var26.appendRow();
               var26.setItemValue(var34, "conid", var11);
               var26.setItemValue(var34, "sabmsstset", var32);
               var26.setItemValue(var34, "bmsgmoosrecflag", var9);
               ++var29;
            }
         }

         return 0;
      }
   }

   private void a() {
      String var2 = null;
      String var3 = null;
      if (this.dbmodel.getRowCount() <= 0) {
         this.warnMessage("警告", "请查询后，选择单据执行\"完成\"操作!");
      } else if (this.getTable().getSelectedRowCount() <= 0) {
         this.warnMessage("警告", "请选择单据执行\"完成\"操作!");
      } else if (this.getTable().getRow() == this.dbmodel.getRowCount()) {
         this.warnMessage("警告", "请正确选择单据!");
      } else {
         for(int var4 = 0; var4 < this.getTable().getRowCount(); ++var4) {
            if (this.getModifiedDbmodel().getRowCount() > 0) {
               this.warnMessage("警告", "没有保存不能执行\"完成\",请先保存!");
               return;
            }
         }

         DBTableModel var1 = ((Bms_sa_con_frame)this.getParentFrame()).getCondtlModel();
         String var16 = "";

         for(int var5 = 0; var5 < var1.getRowCount(); ++var5) {
            var2 = var1.getItemValue(var5, "saplaceqty");
            var3 = var1.getItemValue(var5, "accstqty");
            if (DecimalHelper.toDec(var2).compareTo(DecimalHelper.toDec(var3)) > 0) {
               var16 = "有已分配的明细尚未执行，";
            }
         }

         if (var16.equals("")) {
            var16 = "是否要将此订单完成？";
         } else {
            var16 = var16 + "是否要将此订单完成？";
         }

         if (JOptionPane.showConfirmDialog(this.getParentFrame(), var16, "提示", 2) == 0) {
            int var10 = this.getRow();
            String var11 = this.getItemValue(var10, "conid");
            ClientRequest var13 = new ClientRequest();
            StringCommand var15 = new StringCommand("Bms_sa_con_mde.销售订单完成");
            ParamCommand var17;
            (var17 = new ParamCommand()).addParam("conid", var11);
            var13.addCommand(var15);
            var13.addCommand(var17);
            this.setWaitCursor();

            try {
               StringCommand var12;
               if ((var12 = (StringCommand)SendHelper.sendRequest(var13).commandAt(0)).getString().startsWith("+OK")) {
                  this.infoMessage("提示", "\"完成\"操作成功！");
                  this.doRequery();
               } else if (var12.getString().startsWith("-ERROR")) {
                  int var14 = var12.getString().indexOf(58);
                  this.warnMessage("提示", "\"完成\"操作失败：" + var12.getString().substring(var14 + 1));
                  return;
               }

               return;
            } catch (Exception var8) {
               this.errorMessage("错误", var8.getMessage());
            } finally {
               this.setDefaultCursor();
            }

         }
      }
   }

   private DBTableModel a(String var1, String var2) {
      ClientRequest var3 = new ClientRequest();
      StringCommand var4 = null;
      var4 = new StringCommand("销售订单分配:查询货品配额销售信息");
      ParamCommand var5 = null;
      (var5 = new ParamCommand()).addParam("goodsid", var1);
      var5.addParam("customid", var2);
      var3.addCommand(var4);
      var3.addCommand(var5);

      try {
         ServerResponse var8;
         StringCommand var9;
         if ((var9 = (StringCommand)(var8 = SendHelper.sendRequest(var3)).commandAt(0)).getString().startsWith("+OK")) {
            DBTableModel var7;
            if ((var7 = ((DataCommand)var8.commandAt(1)).getDbmodel()) != null && var7.getRowCount() > 0) {
               return var7;
            }

            this.infoMessage("提示", "查询货品配额销售信息出错:" + var9.getString());
            return null;
         }
      } catch (Exception var6) {
         var6.printStackTrace();
         this.infoMessage("提示", "查询货品配额销售信息出错:" + var6.getMessage());
      }

      return null;
   }

   private void b() {
      DBTableModel var1 = ((Bms_sa_con_frame)this.getParentFrame()).getCondtlModel();
      String var2 = null;
      int var3 = 0;
      if (this.getRow() < 0) {
         this.warnMessage("警告", "请选择正确的订单进行执行!");
      } else if (this.getRow() == this.getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的订单进行执行!");
      } else {
         for(int var4 = 0; var4 < this.getRowCount(); ++var4) {
            if (this.getdbStatus(var4) != 0) {
               this.warnMessage("警告", "有尚未保存的数据,请先做保存!");
               return;
            }
         }

         int[] var22;
         int var5 = (var22 = this.getTable().getSelectedRows()).length;
         if (var22[var22.length - 1] == this.getRowCount()) {
            --var5;
         }

         String var7;
         for(int var6 = 0; var6 < var1.getRowCount(); ++var6) {
            var2 = var1.getItemValue(var6, "saplaceqty");
            var7 = var1.getItemValue(var6, "accstqty");
            if (DecimalHelper.toDec(DecimalHelper.sub(var2, var7, 6)).compareTo(new BigDecimal("0")) > 0) {
               ++var3;
            }
         }

         if (var3 == 0) {
            this.infoMessage("提示", "没有需要执行的单据，请检查是否已经分配或者分配的数量已经执行完成！");
         } else {
            Vector var16 = new Vector();
            DBColumnDisplayInfo var20 = new DBColumnDisplayInfo("conid", "number");
            var16.add(var20);
            var20 = new DBColumnDisplayInfo("message", "varchar");
            var16.add(var20);
            var20 = new DBColumnDisplayInfo("autofix", "number");
            var16.add(var20);
            var20 = new DBColumnDisplayInfo("autokeep", "number");
            var16.add(var20);
            var20 = new DBColumnDisplayInfo("autofixraise", "number");
            var16.add(var20);
            var20 = new DBColumnDisplayInfo("allowfix", "number");
            var16.add(var20);
            DBTableModel var26 = new DBTableModel(var16);
            var7 = this.getApvalue("自动出库配货");
            String var17 = this.getApvalue("自动出库记保管账");
            var2 = this.getApvalue("自提允许配货");
            String var21 = this.getApvalue("是否在生成发货单时取消按批号批次货位分组");
            String var8 = this.getApvalue("准许出库配货");

            for(int var9 = 0; var9 < var5; ++var9) {
               String var10 = this.getItemValue(var22[var9], "conid");
               int var11 = var26.getRowCount();
               var26.appendRow();
               var26.setItemValue(var11, "conid", var10);
               var26.setItemValue(var11, "autofix", var7);
               var26.setItemValue(var11, "autokeep", var17);
               var26.setItemValue(var11, "autofixraise", var2);
               var26.setItemValue(0, "allowfix", var8);
            }

            ClientRequest var28 = new ClientRequest();
            StringCommand var29 = new StringCommand("Bms_sa_con_mde.销售订单发货订单执行");
            DataCommand var30 = new DataCommand();
            ParamCommand var18;
            (var18 = new ParamCommand()).addParam("canelNo", var21);
            var30.setDbmodel(var26);
            var28.addCommand(var29);
            var28.addCommand(var30);
            var28.addCommand(new StringCommand(this.getEntryid()));
            var28.addCommand(new StringCommand(this.saconmultiexec));
            var28.addCommand(var18);
            this.setWaitCursor();

            try {
               ServerResponse var19;
               StringCommand var23;
               if ((var23 = (StringCommand)(var19 = SendHelper.sendRequest(var28)).commandAt(0)).getString().startsWith("+OK")) {
                  DBTableModel var25 = ((DataCommand)var19.commandAt(1)).getDbmodel();
                  var17 = ((StringCommand)var19.commandAt(3)).getString();
                  var21 = "";
                  String var24 = "";

                  for(var5 = 0; var5 < var25.getRowCount(); ++var5) {
                     String var27 = var25.getItemValue(var5, "message");
                     var7 = var25.getItemValue(var5, "warn");
                     if (!var27.startsWith("+OK")) {
                        var21 = var21 + var25.getItemValue(var5, "conid") + "、";
                        if (var27 != null && var27.trim().length() > 0) {
                           var24 = var24 + "\n" + var27.substring(7);
                        } else {
                           var24 = var24 + "\n" + var7;
                        }
                     }
                  }

                  if ("".equals(var21)) {
                     if ("1".equals(var17)) {
                        this.infoMessage("提示", "订单执行成功！ 有赠品出入库单生成，请注意！");
                     } else {
                        this.infoMessage("提示", "订单执行成功！");
                     }

                     ((Bms_sa_con_frame)this.getParentFrame()).getModelCondtl().doRequery();
                     return;
                  } else {
                     if ((var21 = var21.substring(0, var21.length() - 1)).indexOf("、") >= 0) {
                        this.infoMessage("提示", "ID为" + var21 + "的订单执行失败,原因分别为:" + var24);
                     } else {
                        this.infoMessage("提示", "ID为" + var21 + "的订单执行失败,原因为:" + var24);
                     }

                     return;
                  }
               }

               this.errorMessage("错误", "订单执行不成功,原因:" + var23.getString());
               return;
            } catch (Exception var14) {
               this.errorMessage("错误", var14.getMessage());
            } finally {
               this.setDefaultCursor();
            }

         }
      }
   }

   public String getHovOtherWheres(int var1, String var2) {
      String var3 = this.getEntryid();
      return var2.equals("agentid") ? "type=2 and (entryid is null or entryid=" + var3 + ")" : super.getHovOtherWheres(var1, var2);
   }
}
